#!/usr/bin/env python
# _*_ coding: iso-8859-1 _*_

from distutils.core import setup
import py2exe
import os, shutil

from eole import versioneole
from eole.manifest import manifest

os.environ['path']='%s;%s'%(os.environ['path'], os.path.join(os.path.abspath('.'), 'dlls'))

dist_dir = "dists\\updater"
if os.path.exists(dist_dir):
    shutil.rmtree(dist_dir)

if os.path.exists("build"):
    shutil.rmtree("build")

opts = {"py2exe": {
                   "dist_dir": dist_dir,
                   "packages":["encodings",],
                   "optimize":1,
}}

setup(name = 'updater',
      version = versioneole.CLISCRIBE_VERSION_UPDATE,
      description = 'Utilitaire de mise  jour du client Scribe',
      author = 'Eole',
      author_email = 'eole@ac-dijon.fr',
      options=opts,
      url = 'http://eole.orion.education.fr/diffusion',
      service = [{'modules': 'servupdate',
                  'other_resources': [(24, 1, manifest%{'prog': 'ServscribeMAJ'})],
                  'icon_resources': [(1, 'images/eole.ico')]
                }],
      data_files=[("images", ['images/eole.ico']),
                  ('', ['dlls/gdiplus.dll', 'dlls/MSVCP71.dll']),
      ])


