; Fichier InnoSetup de cration de l'installeur de NuWinC
;
; utilisation de "QuickStart Pack" http://www.jrsoftware.org/isdl.php#qsp
; installation de Inno Setup, ISTools, ISPP
;
; ce fichier ncessite :
; - la prsence de :
; * C:\WINDOWS\Eole_inst\NuWINc_inst\common
;                                    WIN2K
;                                    WIN9X
;                                    WINXP
;                                    Vista
;
; * les cls de registres sont spcifies dans la partie [Registry].
; Certaines cls sont types avec MinVersion voir la doc InnoSetup pour les dtails

#define InnoNuWinCSources "U:\sources\nuwinc"
#define AppVersion GetFileVersion(AddBackslash(InnoNuWinCSources) + "WINXP\nuwinc.exe")

[Setup]
AppName=NuWinC
VersionInfoDescription=
; AppId sert  reconnaitre l'application
AppId=NuWinC
AppVerName=NuWinC - version Eole/ducation Nationale
AppPublisher=INL
AppPublisherURL=http://inl.fr/
AppSupportURL=http://inl.fr/
AppUpdatesURL=http://inl.fr/
AppVersion={#AppVersion}
;VersionInfoVersion={#AppVersion}
DefaultDirName={win}\Eole
;DefaultDirName={pf}
; interdit la modification du chemin d'installation
DisableDirPage=true
; interdit la modification du chemin de copie des icnes
DisableProgramGroupPage=true
OutputDir={#InnoNuWinCSources}\
OutputBaseFilename=nuwinc-setup
PrivilegesRequired=admin
AllowCancelDuringInstall=false
SetupIconFile=unwinc.ico
UninstallDisplayIcon={app}\nuwinc\nuwinc.exe
;WizardImageFile=eole.bmp
WizardImageFile=nupik-costard-02.bmp
;WizardImageStretch=false
WizardSmallImageFile=bouclier55x58.bmp
;InfoAfterFile=licence_nufw.txt
AlwaysRestart=true
UninstallRestartComputer=true
ShowLanguageDialog=no


[Languages]
Name: french; MessagesFile: compiler:Languages\French.isl

[Files]
; Wipfw copi que si pas dj install, voir "Check"
Source: {#InnoNuWinCSources}\ipfw\ip_fw.sys; DestDir: {win}\system32\drivers\; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace uninsrestartdelete; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9; Check: not IsCliScribeInstalled
Source: {#InnoNuWinCSources}\ipfw\ipfw.exe; DestDir: {win}\system32\; AfterInstall: ConfigWipfw; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace uninsrestartdelete; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9; Check: not IsCliScribeInstalled
; le fichier suivant est gnr aprs l'installation de "config.cmd"
;Source: C:\WINDOWS\Eole\wipfw\wipfw.conf; DestDir: {app}\wipfw\; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace; MinVersion: 0,5.0.2195

; NuFW
Source: {#InnoNuWinCSources}\common\*; DestDir: {app}\NuWINc; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace uninsrestartdelete
Source: {#InnoNuWinCSources}\WIN9X\*; DestDir: {app}\NuWINc; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace uninsrestartdelete; MinVersion: 4.1.1998,4.0.1381; OnlyBelowVersion: 0,4.0.1381sp9
Source: {#InnoNuWinCSources}\WIN2K_SP3\*; DestDir: {app}\NuWINc; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace uninsrestartdelete; MinVersion: 0,5.0.2195sp3; OnlyBelowVersion: 0,5.0.2195sp9
Source: {#InnoNuWinCSources}\WINXP\*; DestDir: {app}\NuWINc; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace uninsrestartdelete; MinVersion: 0,5.01.2600; OnlyBelowVersion: 0,5.02.3790sp9
Source: {#InnoNuWinCSources}\VISTA\nuwinc.exe; DestDir: {app}\NuWINc; Flags: ignoreversion recursesubdirs createallsubdirs restartreplace uninsrestartdelete; MinVersion: 0,6.0.6000
Source: {#InnoNuWinCSources}\VISTA\nuwinc-drv.inf; DestDir: {sys}; Flags: ignoreversion restartreplace uninsrestartdelete; MinVersion: 0,6.0.6000
Source: {#InnoNuWinCSources}\VISTA\nuwinc-drv.sys; DestDir: {sys}; Flags: ignoreversion restartreplace uninsrestartdelete; MinVersion: 0,6.0.6000; Languages: 

[Icons]
Name: {group}\NuWinC; Filename: {app}\NuWINc\nuwinc.exe; WorkingDir: {app}\NuWINc\; IconFilename: {app}\NuWINc\nuwinc.exe; Comment: Client NuFw

[Registry]
; NuFW
; remplac par "{app}\NuWINc\gina_reg.exe install/uninstall"
;Root: HKLM; SubKey: SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon; ValueType: string; ValueName: GinaDLL; ValueData: {app}\NuWINc\nugina.dll; MinVersion: 0,5.0.2195; Languages: ; Flags: uninsdeletevalue; OnlyBelowVersion: 0,5.01.2600sp9
Root: HKLM; SubKey: SOFTWARE\INL\NuWINc; ValueType: string; ValueName: BinPath; ValueData: {app}\NuWINc\nuwinc.exe; Flags: uninsdeletevalue uninsdeletekeyifempty
; Activ par dfaut
;Root: HKLM; SubKey: SOFTWARE\INL\NuWINc; ValueType: dword; ValueName: Disabled; ValueData: $00000001; Flags: uninsdeletevalue uninsdeletekeyifempty

[Run]
; Pour 2000 et XP (WipFw)
Filename: {win}\system32\ipfw.exe; Parameters: install_drv {win}\System32\DRIVERS\ip_fw.sys; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
Filename: {sys}\net.exe; Parameters: start ip_fw; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
Filename: {win}\system32\ipfw.exe; Parameters: install {app}\wipfw\config.cmd; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
Filename: {sys}\net.exe; Parameters: start ipfw; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
;Filename: {app}\wipfw\install.cmd; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
; Vista (NuFw)
; plus besoin, seulement un outils de test pour vista
;Filename: {app}\NuWINc\nuwinc-netstat.exe; Parameters: install; Flags: runhidden; MinVersion: 0,6.0.6000
Filename: {sys}\rundll32.exe; Parameters: setupapi.dll,InstallHinfSection DefaultInstall 128 nuwinc-drv.inf; Flags: runhidden; MinVersion: 0,6.0.6000
Filename: {app}\NuWINc\gina_reg.exe; Parameters: install; Flags: runhidden

[UninstallRun]
; NT, 2000 et XP
Filename: {sys}\net.exe; Parameters: stop /y ip_fw; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
Filename: {win}\system32\ipfw.exe; Parameters: remove_drv; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
Filename: {win}\system32\ipfw.exe; Parameters: remove; Flags: runhidden; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600sp9
; Vista
; Dsinstallation de NuFw (voir C:\WINDOWS\Eole_inst\NuWINc_inst\VISTA\install_drv.bat
Filename: {sys}\rundll32.exe; Parameters: setupapi.dll,InstallHinfSection DefaultUninstall 128 nuwinc-drv.inf; Flags: runhidden; MinVersion: 0,6.0.6000
Filename: {app}\NuWINc\gina_reg.exe; Parameters: uninstall; Flags: runhidden
; plus besoin, seulement un outils de test pour vista
;Filename: {app}\NuWINc\nuwinc-netstat.exe; Parameters: uninstall; Flags: runhidden; MinVersion: 0,6.0.6000

[UninstallDelete]
Name: {app}\wipfw\wipfw.conf; Type: files; MinVersion: 0,4.0.1381; OnlyBelowVersion: 0,5.01.2600sp9
Name: {app}\wipfw\config.cmd; Type: files; MinVersion: 0,4.0.1381; OnlyBelowVersion: 0,5.01.2600sp9
Name: {app}\wipfw\install.cmd; Type: files; MinVersion: 0,4.0.1381; OnlyBelowVersion: 0,5.01.2600sp9
Name: {app}\wipfw; Type: dirifempty; MinVersion: 0,4.0.1381; OnlyBelowVersion: 0,5.01.2600sp9

[Tasks]

[Code]
// Copie "sc.exe" pour les windows 2000
// si prsent dans le dossier de l'installeur {src}
//procedure CopySc();
//var
//  sc: String;
//  scd: String;
//begin
//  sc:=ExpandConstant('{src}\sc.exe');
//  scd:=ExpandConstant('{sys}\sc.exe');
//  if not (GetWindowsVersionString() = '5.00.2195') then begin
//    Exit;
//  end;
//  if not (FileExists(sc)) then begin
//    Exit;
//  end;
//  if not (FileExists(scd)) then begin
//	FileCopy(sc, scd, True)
//    MsgBox('Le fichier "sc.exe" a t copi.', mbInformation, MB_OK);
//  end;
//end;

//###########################################
// Vrifie si le client Scribe ou ipfw seul est install
// il fournit dj IPFW, c'est pour :
// 1) viter d'craser et de planter ipfw
// 2) de pouvoir ds-installer NuWinC sans enlever ipfw
function IsIpfwPresent(): Boolean;
var
  IpfwPathName: String;
begin
  IpfwPathName := ExpandConstant('{win}\system32\ipfw.exe');
  Result := FileExists(IpfwPathName);
end;
//##
function IsCliScribeInstalled(): Boolean;
var
  CliScribePathKeyName, CliScribePathValueName: String;
begin
  CliScribePathKeyName := 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\CliScribe_is1';
  CliScribePathValueName := 'Inno Setup: App Path';
  if IsIpfwPresent then
    Result := True
  else
    Result := RegKeyExists(HKEY_LOCAL_MACHINE, CliScribePathKeyName);
end;
//###########################################

//###########################################
// Configuration Wipfw (2000 et XP), appel  l'install de wipfw\config.cmd
procedure ConfigWipfw();
var
  mydir : String;
  fichier_conf : String;
  fichier_config : String;
  fichier_install : String;
  s : String;
  s2 : String;
  s3 : String;
begin
  // Cration du rpertoire
  mydir:=ExpandConstant('{app}\wipfw');
  if ( not DirExists( mydir ) ) then
    CreateDir( mydir );
  // Fichier "wpkg.conf" contenant les rgles par dfaut
  fichier_conf:=ExpandConstant('{app}\wipfw\wipfw.conf');
  s:='# First flush the firewall rules'+#13#10;
  s:=s+'-f flush'+#13#10+#13#10;
  s:=s+'add 001 allow all from any to any via lo*'+#13#10;
  s:=s+'# check-state + keep-state = related, established en iptables'+#13#10;
  s:=s+'add 002 check-state'+#13#10;
  s:=s+'# A ajouter pour NuWinC'+#13#10;
  s:=s+'add 65533 allow udp from me to any keep-state'+#13#10;
  s:=s+'add 65534 allow ip from any to any'+#13#10;

  if ( FileExists( fichier_conf ) ) then
    DeleteFile( fichier_conf ) ;
  SaveStringToFile(fichier_conf, s, False);

  // Fichier "config.cmd" sert  configurer ipfw
  fichier_config:=ExpandConstant('{app}\wipfw\config.cmd');
  s2:='set curd=%cd%'+#13#10;
  s2:=s2+'cd %systemroot%\system32'+#13#10;
  s2:=s2+'"%cd%\ipfw" "'+fichier_conf+'"'+#13#10;
  s2:=s2+'cd %curd%'+#13#10;


  if ( FileExists( fichier_config ) ) then
    DeleteFile( fichier_config ) ;
  SaveStringToFile(fichier_config, s2, False);
//
//  // Fichier "install.cmd"
//  fichier_install:=ExpandConstant('{app}\wipfw\install.cmd')
//  s3:='set d=%systemroot%\system32'+#13#10;
//  s3:=s3+'"%d%\ipfw" install_drv System32\DRIVERS\ip_fw.sys'+#13#10;
//  s3:=s3+'net start ip_fw'+#13#10;
//  s3:=s3+'"%d%\ipfw" install "'+fichier_config+'"'+#13#10;
//  s3:=s3+'net start ipfw'+#13#10;
//  s3:=s3+'ipfw -d list'+#13#10;
//  if ( FileExists( fichier_install ) ) then
//    DeleteFile( fichier_install ) ;
//  SaveStringToFile(fichier_install, s3, False);


end;
//###########################################
